options ls=80;
data genauto1;
   u1 = 0;
   do time = -5 to 50;
    u = .5*u1  + rannor(123456);
    y = 10 + .5*time + u;
    if time > 0 then output;
     u1 = u;
   end;
run;

data genauto2;
    u1= 0;
   do time = 35 to 75;
     u = .5*u1 + rannor(345679);
    y = 10 + .5*time + u;
    if time > 50 then output;
    u1 = u;
   end;
run;



proc print data=genauto1;
run;
symbol1 i=join c=green v=star;
symbol2 i=r c=blue v=none;
proc gplot;
  plot Y*time = 1  Y*time=2/overlay;
run;
proc reg;
  model y = time;
output out=resdat r=resid1;
run;

data all;
  merge genauto1 genauto2;
    by time;
  proc print;
run;

proc autoreg data=all;
   model y = time/nlag=6 method=ml dwprob;
   output out=resdat2 r=resid2 ucl=ucl lcl=lcl p=forecast pm=ytrend;
run;
proc arima data=genauto1;
i var=u center;
e p=1 printall plot ;
run;

data resck;
  set resdat2;
proc print;
run;

proc arima;
  i var=resid2;
run;
data together;
  set resdat2;
  if time < 50 then forecast = .;
  if time < 50 then ucl = .;
  if time < 50 then lcl = .;
 run;






/* generates the x-axis value above the reference line */
data anno;
  input time 1-4 text $ 5-58;
function='label'; angle = 90 ; xsys='2'; ysys='1';
x=time; y=50; position='B';
cards;
  50  Out of sample Forecast begins here
;
axis1 label=(a=90 'Simulated Y(t)');
symbol1 i=join c=blue v=star;
symbol2 i=join c=green v=F;
symbol3 i=join c=black line=1;
symbol4 i=join c=red line=20;
symbol5 i=join c=red line=20;
proc gplot data=together;
  plot (y forecast ytrend lcl ucl) * time/overlay vaxis=axis1 href=50
  annotate=anno;
  where time > 35 and time < 55;
title 'Forecast Profile of Regression with Simulated AR(1) Errors';
title2 'Star=actual data, F=forecast, solid line=trend line ';
title3  'Dotted lines=forecast interval limits';
run;
